<?php

	if ( ! function_exists( 'zleadscrm_get_users_allowed_basic_search_setting' ) ) {
		function zleadscrm_get_users_allowed_basic_search_setting() {
			return get_option( 'zleadscrm_users_allowed_basic_search_setting', 'all' );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_search_users' ) ) {
		function zleadscrm_get_basic_search_users() {
			return get_option( 'zleadscrm_allowed_basic_search_users', [] );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_users_allowed_prospect_setting' ) ) {
		function zleadscrm_get_users_allowed_prospect_setting() {
			return get_option( 'zleadscrm_users_allowed_prospect_setting', 'all' );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_prospect_users' ) ) {
		function zleadscrm_get_prospect_users() {
			return get_option( 'zleadscrm_allowed_prospect_users', [] );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_users_allowed_advanced_search_setting' ) ) {
		function zleadscrm_get_users_allowed_advanced_search_setting() {
			return get_option( 'zleadscrm_users_allowed_advanced_search_setting', 'all' );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_advanced_search_users' ) ) {
		function zleadscrm_get_advanced_search_users() {
			return get_option( 'zleadscrm_allowed_advanced_search_users', [] );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_users_allowed_access_my_bookmarks_setting' ) ) {
		function zleadscrm_get_users_allowed_access_my_bookmarks_setting() {
			return get_option( 'zleadscrm_users_allowed_access_my_bookmarks_setting', 'all' );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_access_my_bookmarks_users' ) ) {
		function zleadscrm_get_access_my_bookmarks_users() {
			return get_option( 'zleadscrm_allowed_access_my_bookmarks_users', [] );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_users_allowed_access_all_bookmarks_setting' ) ) {
		function zleadscrm_get_users_allowed_access_all_bookmarks_setting() {
			return get_option( 'zleadscrm_users_allowed_access_all_bookmarks_setting', 'all' );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_access_all_bookmarks_users' ) ) {
		function zleadscrm_get_access_all_bookmarks_users() {
			return get_option( 'zleadscrm_allowed_access_all_bookmarks_users', [] );
		}
	}

	if ( ! function_exists( 'zleadscrm_user_can_do_advanced_search' ) ) {
		function zleadscrm_user_can_do_advanced_search( $user_id ) {
			$roles = zleadscrm_get_selected_roles();

			$user_roles = get_user_by( 'id', $user_id )->roles;

			foreach ( $user_roles as $user_role ) {
				if ( ! in_array( $user_role, $roles ) ) {
					return false;
				}
			}

			if ( zleadscrm_get_users_allowed_advanced_search_setting() == 'all' ) {
				return true;
			}
			$allowed_advance_search_users = zleadscrm_get_advanced_search_users();

			return in_array( $user_id, $allowed_advance_search_users );
		}
	}

	if ( ! function_exists( 'zleadscrm_user_can_prospect' ) ) {
		function zleadscrm_user_can_prospect( $user_id ) {
			$roles = zleadscrm_get_selected_roles();

			$user_roles = get_user_by( 'id', $user_id )->roles;

			foreach ( $user_roles as $user_role ) {
				if ( ! in_array( $user_role, $roles ) ) {
					return false;
				}
			}

			if ( zleadscrm_get_users_allowed_prospect_setting() == 'all' ) {
				return true;
			}

			$allowed_prospect_users = zleadscrm_get_prospect_users();

			return in_array( $user_id, $allowed_prospect_users );
		}
	}

	if ( ! function_exists( 'zleadscrm_user_can_do_basic_search' ) ) {
		function zleadscrm_user_can_do_basic_search( $user_id ) {
			$roles = zleadscrm_get_selected_roles();

			$user_roles = get_user_by( 'id', $user_id )->roles;

			foreach ( $user_roles as $user_role ) {
				if ( ! in_array( $user_role, $roles ) ) {
					return false;
				}
			}

			if ( zleadscrm_get_users_allowed_basic_search_setting() == 'all' ) {
				return true;
			}

			if ( zleadscrm_user_can_do_advanced_search( $user_id ) ) {
				return true;
			}

			$allowed_basic_search_users = zleadscrm_get_basic_search_users();

			return in_array( $user_id, $allowed_basic_search_users );
		}
	}

	if ( ! function_exists( 'zleadscrm_user_can_access_my_bookmarks' ) ) {
		function zleadscrm_user_can_access_my_bookmarks( $user_id ) {
			$roles = zleadscrm_get_selected_roles();

			$user_roles = get_user_by( 'id', $user_id )->roles;

			foreach ( $user_roles as $user_role ) {
				if ( ! in_array( $user_role, $roles ) ) {
					return false;
				}
			}

			if ( zleadscrm_get_users_allowed_access_my_bookmarks_setting() == 'all' ) {
				return true;
			}

			$allowed_access_my_bookmarks_users = zleadscrm_get_access_my_bookmarks_users();

			return in_array( $user_id, $allowed_access_my_bookmarks_users );
		}
	}

	if ( ! function_exists( 'zleadscrm_user_can_access_all_bookmarks' ) ) {
		function zleadscrm_user_can_access_all_bookmarks( $user_id ) {
			$roles = zleadscrm_get_selected_roles();

			$user_roles = get_user_by( 'id', $user_id )->roles;

			foreach ( $user_roles as $user_role ) {
				if ( ! in_array( $user_role, $roles ) ) {
					return false;
				}
			}

			if ( zleadscrm_get_users_allowed_access_all_bookmarks_setting() == 'all' ) {
				return true;
			}

			$allowed_access_all_bookmarks_users = zleadscrm_get_access_all_bookmarks_users();

			return in_array( $user_id, $allowed_access_all_bookmarks_users );
		}
	}

	if ( ! function_exists( 'zleadscrm_upload_new_lead_result' ) ) {
		function zleadscrm_upload_new_lead_result( $result ) {
			global $wpdb;

			$table_name = $wpdb->prefix . 'zleadscrm_leads_results';


			$btype = '';

			foreach ( $result['business_type'] as $bt ) {
				$btype .= $bt . ';';
			}

			$wpdb->insert(
				$table_name,
				array(
					'timestamp'     => $result['timestamp'],
					'user_id'       => $result['user_id'],
					'business_name' => isset( $result['business_name'] ) ? $result['business_name'] : ' ',
					'business_type' => isset( $btype ) ? $btype : ' ',
					'phone'         => isset( $result['phone'] ) ? $result['phone'] : ' ',
					'website'       => isset( $result['website'] ) ? $result['website'] : ' ',
					'address'       => isset( $result['address'] ) ? $result['address'] : ' ',
					'url'           => isset( $result['url'] ) ? $result['url'] : ' '
				)
			);
		}
	}

	if ( ! function_exists( 'zleadscrm_delete_user_results' ) ) {
		function zleadscrm_delete_user_results( $user_id ) {
			global $wpdb;

			$table_name = $wpdb->prefix . 'zleadscrm_leads_results';

			$wpdb->delete( $table_name, array( 'user_id' => $user_id ) );
		}
	}

	if ( ! function_exists( 'zleadscrm_insert_bookmark' ) ) {
		function zleadscrm_insert_bookmark( $bookmark ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_bookmarks';

			$wpdb->insert( $table_name, array(
				'timestamp'     => current_time( 'mysql' ),
				'business_name' => $bookmark['business_name'],
				'business_type' => $bookmark['business_type'],
				'phone'         => $bookmark['phone'],
				'website'       => $bookmark['website'],
				'address'       => $bookmark['address'],
				'owner_id'      => $bookmark['owner'],
				'url'           => $bookmark['url']
			) );
		}
	}

	if ( ! function_exists( 'zleadscrm_get_advanced_request_this_week' ) ) {
		function zleadscrm_get_advanced_request_this_week( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$day        = date( 'w' );
			$week_start = date( 'Y-m-d 00:00:00', strtotime( '-' . $day . ' days' ) );
			$week_end   = date( 'Y-m-d 23:59:59', strtotime( '+' . ( 6 - $day ) . ' days' ) );

			$result = $wpdb->get_results( "SELECT SUM(advanced_requests) AS advanced_requests FROM $table_name WHERE timestamp<='$week_end' AND timestamp>='$week_start' AND user_id=$user_id;" );

			return isset( $result[0]->advanced_requests ) ? $result[0]->advanced_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_advanced_request_this_month' ) ) {
		function zleadscrm_get_advanced_request_this_month( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$month_start = date( 'Y-m-01 00:00:00' );
			$month_end   = date( 'Y-m-d 23:59:59', strtotime( 'last day of this month' ) );


			$result = $wpdb->get_results( "SELECT SUM(advanced_requests) AS advanced_requests FROM $table_name WHERE timestamp<='$month_end' AND timestamp>='$month_start' AND user_id=$user_id;" );

			return isset( $result[0]->advanced_requests ) ? $result[0]->advanced_requests : 0;
		}
	}


	if ( ! function_exists( 'zleadscrm_get_basic_request_this_week' ) ) {
		function zleadscrm_get_basic_request_this_week( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$day        = date( 'w' );
			$week_start = date( 'Y-m-d 00:00:00', strtotime( '-' . $day . ' days' ) );
			$week_end   = date( 'Y-m-d 23:59:59', strtotime( '+' . ( 6 - $day ) . ' days' ) );

			$result = $wpdb->get_results( "SELECT SUM(basic_requests) AS basic_requests FROM $table_name WHERE timestamp<='$week_end' AND timestamp>='$week_start' AND user_id=$user_id;" );

			return isset( $result[0]->basic_requests ) ? $result[0]->basic_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_request_this_month' ) ) {
		function zleadscrm_get_basic_request_this_month( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$month_start = date( 'Y-m-01 00:00:00' );
			$month_end   = date( 'Y-m-d 23:59:59', strtotime( 'last day of this month' ) );


			$result = $wpdb->get_results( "SELECT SUM(basic_requests) AS basic_requests FROM $table_name WHERE timestamp<='$month_end' AND timestamp>='$month_start' AND user_id=$user_id;" );

			return isset( $result[0]->basic_requests ) ? $result[0]->basic_requests : 0;
		}
	}
	if ( ! function_exists( 'zleadscrm_get_week_limit_type' ) ) {
		function zleadscrm_get_week_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_month_limit_type' ) ) {
		function zleadscrm_get_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_week_limit_type' ) ) {
		function zleadscrm_get_basic_week_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_month_limit_type' ) ) {
		function zleadscrm_get_basic_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_can_do_more_advanced_searches_this_month' ) ) {
		function zleadscrm_can_do_more_advanced_searches_this_month( $user_id, $current_items ) {
			$max_number_of_searches     = (int) get_user_meta( $user_id, 'zleadscrm_month_max_advanced_requests', true );
			$current_number_of_searches = (int) zleadscrm_get_advanced_request_this_month( $user_id );

			$type = zleadscrm_get_month_limit_type( $user_id );
			if ( $type == 'unlimited' ) {
				return true;
			}


			if ( $current_number_of_searches + $current_items < $max_number_of_searches ) {
				return true;
			}

			return false;
		}
	}

	if ( ! function_exists( 'zleadscrm_can_do_more_advanced_searches_this_week' ) ) {
		function zleadscrm_can_do_more_advanced_searches_this_week( $user_id, $current_items ) {
			$max_number_of_searches     = (int) get_user_meta( $user_id, 'zleadscrm_week_max_advanced_requests', true );
			$current_number_of_searches = (int) zleadscrm_get_advanced_request_this_week( $user_id );


			$type = zleadscrm_get_week_limit_type( $user_id );
			if ( $type == 'unlimited' ) {
				return true;
			}


			if ( $current_number_of_searches + $current_items < $max_number_of_searches ) {
				return true;
			}


			return false;
		}
	}

	if ( ! function_exists( 'zleadscrm_can_do_more_basic_searches_this_month' ) ) {
		function zleadscrm_can_do_more_basic_searches_this_month( $user_id, $current_items ) {
			$max_number_of_searches     = (int) get_user_meta( $user_id, 'zleadscrm_month_max_basic_requests', true );
			$current_number_of_searches = (int) zleadscrm_get_basic_request_this_month( $user_id );

			$type = zleadscrm_get_month_limit_type( $user_id );
			if ( $type == 'unlimited' ) {
				return true;
			}


			if ( $current_number_of_searches + $current_items < $max_number_of_searches ) {
				return true;
			}

			return false;
		}
	}

	if ( ! function_exists( 'zleadscrm_can_do_more_basic_searches_this_week' ) ) {
		function zleadscrm_can_do_more_basic_searches_this_week( $user_id, $current_items ) {
			$max_number_of_searches     = (int) get_user_meta( $user_id, 'zleadscrm_week_max_basic_requests', true );
			$current_number_of_searches = (int) zleadscrm_get_basic_request_this_week( $user_id );


			$type = zleadscrm_get_week_limit_type( $user_id );
			if ( $type == 'unlimited' ) {
				return true;
			}


			if ( $current_number_of_searches + $current_items < $max_number_of_searches ) {
				return true;
			}

			return false;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_number_of_bookmarks' ) ) {
		function zleadscrm_get_number_of_bookmarks( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_bookmarks';

			if ( ! isset( $_GET['range'] ) ) {
				$range = 'all';
			} else {
				$range = sanitize_text_field( $_GET['range'] );
			}
			switch ( $range ) {
				case '7day':
					$start_date = date( 'Y-m-d 00:00:00', strtotime( '-7 day' ) );
					$end_date   = date( 'Y-m-d 23:59:59' );
					break;
				case 'month':
					$start_date = date( 'Y-m-01 00:00:00' );
					$end_date   = date( 'Y-m-d 23:59:59' );
					break;
				case 'last_month' :
					$start_date = date( 'Y-m-01 00:00:00', strtotime( '-1 month' ) );
					$end_date   = date( 'Y-m-d 23:59:59', strtotime( 'last day of previous month' ) );
					break;
				case 'year':
					$start_date = date( 'Y-01-01 00:00:00' );
					$end_date   = date( 'Y-m-d 23:59:59' );
					break;
				case 'custom':
					$start_date = sanitize_text_field( $_GET['start_date'] );
					$end_date   = sanitize_text_field( $_GET['end_date'] );
					break;
				default:
					$start_date = date( '1970-01-01 00:00:00' );
					$end_date   = date( 'Y-m-d 23:59:59' );
					break;
			}

			$result = $wpdb->get_results( "SELECT COUNT(*) AS total FROM $table_name WHERE timestamp<='$end_date' AND timestamp>='$start_date' AND owner_id=$user_id;" );

			return isset( $result[0]->total ) ? (int) $result[0]->total : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_week_limit_type' ) ) {
		function zleadscrm_get_week_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_month_limit_type' ) ) {
		function zleadscrm_get_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_month_limit_type' ) ) {
		function zleadscrm_get_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_month_limit_type' ) ) {
		function zleadscrm_get_basic_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_display_prospect_settings' ) ) {
		function zleadscrm_display_prospect_settings() {
			include_once( ZLEADSCRM_PROSPECT_PLUGIN_DIR . 'template/settings.php' );
		}
	}

?>