<?php
	if ( ! defined( 'ABSPATH' ) ) {
		exit; // Exit if accessed directly.
	}

	$limit_number      = get_option( 'zleadscrm_limit_call_number' );
	$google_places_api = get_option( 'zleadscrm_google_places_api_key' );

	if ( ! isset( $limit_number ) || $limit_number == '' ) {
		$limit_number = 60;
	}

	$users_query = new WP_User_Query( array(
		'role__in' => zleadscrm_get_selected_roles()
	) );

	$users = $users_query->get_results();

	$zleadscrm_users_allowed_prospect_setting             = zleadscrm_get_users_allowed_prospect_setting();
	$allowed_prospect_users                            = zleadscrm_get_prospect_users();
	$zleadscrm_users_allowed_access_my_bookmarks_setting  = zleadscrm_get_users_allowed_access_my_bookmarks_setting();
	$allowed_access_my_bookmarks_users                 = zleadscrm_get_access_my_bookmarks_users();
	$zleadscrm_users_allowed_access_all_bookmarks_setting = zleadscrm_get_users_allowed_access_all_bookmarks_setting();
	$allowed_access_all_bookmarks_users                = zleadscrm_get_access_all_bookmarks_users();
	$zleadscrm_users_allowed_basic_search_setting         = zleadscrm_get_users_allowed_basic_search_setting();
	$allowed_basic_search_users                        = zleadscrm_get_basic_search_users();
	$zleadscrm_users_allowed_advanced_search_setting      = zleadscrm_get_users_allowed_advanced_search_setting();
	$allowed_advanced_search_users                     = zleadscrm_get_advanced_search_users();
	$zleadscrm_users_allowed_company_setting              = zleadscrm_get_users_allowed_company_setting();
	$allowed_company_users                             = zleadscrm_get_company_users();

	if ( zleadscrm_allow_edit_settings() == false ) {
		echo '<div class="zleadscrm_not_allowed_wrap">';
		echo '<p>Sorry, you are not allowed to access this page!</p>';
		echo '</div>';
		exit;
	}

?>
<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access Prospect Functionality </b></label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_prospect_setting_all"
                   name="zleadscrm_users_allowed_prospect_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_prospect_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_prospect_setting_users"
                   name="zleadscrm_users_allowed_prospect_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_prospect_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_prospect_list_container">
        <select id="zleadscrm_users_prospect_list"
                name="zleadscrm_allowed_prospect_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_prospect_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access My Bookmarks Functionality </b></label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_access_my_bookmarks_setting_all"
                   name="zleadscrm_users_allowed_access_my_bookmarks_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_access_my_bookmarks_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_access_my_bookmarks_setting_users"
                   name="zleadscrm_users_allowed_access_my_bookmarks_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_access_my_bookmarks_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_access_my_bookmarks_list_container">
        <select id="zleadscrm_users_access_my_bookmarks_list"
                name="zleadscrm_allowed_access_my_bookmarks_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_access_my_bookmarks_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access All Bookmarks
            Functionality </b></label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_access_all_bookmarks_setting_all"
                   name="zleadscrm_users_allowed_access_all_bookmarks_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_access_all_bookmarks_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_access_all_bookmarks_setting_users"
                   name="zleadscrm_users_allowed_access_all_bookmarks_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_access_all_bookmarks_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_access_all_bookmarks_list_container">
        <select id="zleadscrm_users_access_all_bookmarks_list"
                name="zleadscrm_allowed_access_all_bookmarks_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_access_all_bookmarks_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access Company Analytics and Modify User
            Limits </b></label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_company_setting_all"
                   name="zleadscrm_users_allowed_company_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_company_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_company_setting_users"
                   name="zleadscrm_users_allowed_company_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_company_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_company_list_container">
        <select id="zleadscrm_users_company_list"
                name="zleadscrm_allowed_company_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_company_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access Basic Prospect Search
            Functionality </b>(No
        Google API Charges for Basic Search)</label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_basic_search_setting_all"
                   name="zleadscrm_users_allowed_basic_search_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_basic_search_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_basic_search_setting_users"
                   name="zleadscrm_users_allowed_basic_search_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_basic_search_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_basic_search_list_container">
        <select id="zleadscrm_users_basic_search_list"
                name="zleadscrm_allowed_basic_search_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_basic_search_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div style="margin-top: 20px;">
    <label style="margin: 10px 0 10px 0;"><b>Users Allowed to Access Advanced Prospect Search
            Functionality </b>(Google
        API Charges apply, <a
                href="https://developers.google.com/places/web-service/usage-and-billing#contact-data">see
            rates</a> )</label>
    <div style=" margin-top: 10px; margin-bottom: 20px; margin-left:10px;">
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_advanced_search_setting_all"
                   name="zleadscrm_users_allowed_advanced_search_setting" value="all" <?php checked(
				'all', $zleadscrm_users_allowed_advanced_search_setting, true ) ?>>All Users
        </div>
        <div style="display:inline; margin-right: 10px;">
            <input type="radio" id="zleadscrm_users_allowed_advanced_search_setting_users"
                   name="zleadscrm_users_allowed_advanced_search_setting" value="users" <?php checked(
				'users', $zleadscrm_users_allowed_advanced_search_setting, true ) ?>>Select Users
        </div>
    </div>

    <div id="zleadscrm_allowed_users_advanced_search_list_container">
        <select id="zleadscrm_users_advanced_search_list"
                name="zleadscrm_allowed_advanced_search_users[]" multiple="multiple">
			<?php if ( $users ) {
				foreach ( $users as $user ) {
					$extra = '';
					if ( in_array( $user->ID, $allowed_advanced_search_users ) ) {
						$extra = 'selected="selected"';
					}
					echo '<option value="' . esc_attr( $user->ID ) . '" ' . $extra . '>' . esc_html( $user->display_name ) . '</option>';
				}
			}
			?>
        </select>
    </div>
</div>

<div>
    <h3 style="font-weight: bold; display: inline-block; margin-right:1rem;">Google Places API</h3>
    <span>To use the Places API, you must enable billing on each of your projects. Cost and billing provided by Google <a
                target="_blank"
                href="https://cloud.google.com/maps-platform/?apis=places">Learn more</a></span>
</div>

<div style="margin: 1rem 0;">
    <label for="zleadscrm_google_places_api_key"
           style="display: inline-block; font-size: 14px; font-weight: bold; margin-right: 1rem;">Google
        Places API Key</label>
    <input type="text" value="<?php echo esc_attr( $google_places_api ); ?>" id="zleadscrm_google_places_api_key"
           name="zleadscrm_google_places_api_key"
           style="width:40%;"/>
    <a class="button" id="zleadscrm_google_places_api_key_reset"
       data-link="<?php echo admin_url( 'admin-ajax.php' ); ?>">Reset</a>
	<?php wp_nonce_field( 'zleadscrm_reset_google_api_key', 'reset_api_key_nonce' ); ?>
</div>
<div>
    <label for="zleadscrm_limit_call_number"><b>Limit Number of Search Call Results</b></label>
    <input type="number" min="20" max="60" step="20" value="<?php echo esc_attr( $limit_number ); ?>"
           style="text-align: center; margin-left: 1rem; margin-right:1rem;"
           id="zleadscrm_limit_call_number"
           name="zleadscrm_limit_call_number"/>
    <span>results per search query</span>
</div>
